#include <ctype.h>
#include <conio.h>
#include <stdio.h>
#include <string.h>
#include "..\allegro\allegro.h"

void display_info(void);

void main(int argc, char *argv[])
{
   FILE *fp;
   unsigned char filename[80];
   unsigned char savename[80];
   unsigned char ch;
   int i,i2;
   int j;
   int x,y;
   long k;
   RGB p;

   filename[0] = 0;
   savename[0] = 0;
   x = 360;
   y = 240;
   for(i=1;i<argc;i++)
   {
      if(!strncmp(argv[i],"-x",2))
      {
         x = 0;
         for(j=2;argv[i][j];j++)
         {
            x = x * 10 + argv[i][j] - '0';
         }
      }
      else if(!strncmp(argv[i],"-y",2))
      {
         y = 0;
         for(j=2;argv[i][j];j++)
         {
            y = y * 10 + argv[i][j] - '0';
         }
      }
      else if(!strncmp(argv[i],"-s",2))
      {
         switch(argv[i][2])
         {
            case '1': x=360;y=240;break;
            case '2': x=640;y=480;break;
            case '3': x=1024;y=768;break;
            default:
               printf("Unrecognized -s option.\n");
               exit(0);
         }
      }
      else if(!strcmp(argv[i],"-h"))
      {
         display_info();
         exit(0);
      }
      else if(!strcmp(argv[i],"-eval"))
      {
         printf("X: %d\n",x);
         printf("Y: %d\n",y);
      }
      else
      {
         if(!filename[0])
            strcpy(filename,argv[i]);
         else
            strcpy(savename,argv[i]);
      }
   }

   if(strlen(filename) == 0)
   {
      if(argc>1)printf("Unrecognized filename.\n\n");
      display_info();
      exit(0);
   }

   if((x > 1024) || (y>768))
   {
      printf("Max X and Y are 1024 and 768, respectively.\n");
      exit(0);
   }

   if(!(fp=fopen(filename,"rb")))
   {
      printf("Unable to open file %s...\n",filename);
      exit(0);
   }

   allegro_init();
   set_gfx_mode(GFX_AUTODETECT,x,y,x,y);

   /*
    * Move the pointer up to the pallete table
    */
   for(k=0;k<79872;k++)
   {
      ch=fgetc(fp);
   }

   /*
    * Read the pallete table.  Each value is a RGB entry with values
    * ranging from 0 - 31 (ie. 32767 = {31,31,31}).
    */
   for(i=0;i<256;i++)
   {
      ch=fgetc(fp);
      j = ch << 8;
      ch=fgetc(fp);
      j |= ch;
      p.r = j % 32;
      j = j / 32;
      p.g = j % 32;
      j = j / 32;
      p.b = j % 32;
      set_color(i,&p);
   }
   rewind(fp);

   /*
    * Now display the pixels using the newly define pallete.
    *
    * The image size is 352 x 224.
    */
   for(j=0;j<224;j++)
   {
      for(i=0;i<352;i++)
      {
         ch=fgetc(fp);
         putpixel(screen,i,j,ch);
      }
   }
   fclose(fp);

   ch = 0;
   do
   {
      switch(tolower(ch))
      {
         case '-':
            for(i=0;i<256;i++)
            {
               get_color(i,&p);
               if(p.r)
                  p.r--;
               if(p.g)
                  p.g--;
               if(p.b)
                  p.b--;
               set_color(i,&p);
            }
            break;
         case '+':
         case '=':
            for(i=0;i<256;i++)
            {
               get_color(i,&p);
               if(p.r < 63)
                  p.r++;
               if(p.g < 63)
                  p.g++;
               if(p.b < 63)
                  p.b++;
               set_color(i,&p);
            }
            break;
         case 's':
            save_pcx(savename,screen,_current_pallete);
            break;
         default:
            break;
      }
      ch=getch();
   } while(tolower(ch)!='q');

   allegro_exit();
}


void display_info(void)
{   
   printf("pakread: Interpret and display a SSFA2 SS*.PAK file.\n");
   printf("Usage:\n");
   printf("   pakread [-s#] filename [savename]\n");
   printf("   -s# : Screen size, where # is one of the following:\n");
   printf("         1 360x240 (DEFAULT)\n");
   printf("         2 640x480\n");
   printf("         3 1024x768\n");
   printf("\nDuring display, the following keys are active:\n");
   printf("- : Darken pallete\n");
   printf("= : Brighten pallete\n");
   printf("s : Save image to .PCX file using savename from command line\n");
   printf("q : Exit view\n");
   printf("\nWritten by Tim Scott, scott@fm-net.com.  Sep. 1997\n");
};
